/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id: slide.js,v 1.1.2.1 2015/06/22 09:21:34 rakollep Exp $ */
 
var SlideController = 
{
	LOWindow : null,
	currLoID : "0",
	currTopicID : "0",
	currGroupID : "0",		
	
	viewSlide : function(uniqueId)
	{
		var sc = SlideController;
	 	slideNum = sc.findSlideNum(uniqueId); 
	 	sc.NewSlide(slideNum);  
	},
	
	doTitle : function(slideNum)
	{
		var title = "";
	    var level = levelArray[slideNum];
	    var count = slideNum;
	    if (level > 0) 
	    {
	      while (level <= 4) 
	      {
	        if (titleArray[count] != "") 
	        {
	          title = titleArray[count] + " -> " +title;
	        }
	        while (levelArray[count] <= level) 
	        {
	          count--;
	        }
	        level = levelArray[count];
	      }
	    }
	    else 
	    {
	      title = titleArray[0];
	    }
	    document.title = unescape(title);
	},
	
	findSlideNum : function(uniqueId) 
	{
		var slideNum = 0; 
	    for (var i=0; i < idArray.length; i++ ) 
	    {  
	        if (idArray[i].uniqueId == uniqueId) 
	        { 
	            slideNum = i;
				break;
	        }  
	    } 
	    return slideNum;  
	},
	
	nextSlide : function()
	{
		var sc = SlideController;
		if (curSlideNum < (slideCount-1))
		{
	        curSlideNum++;
	        var level = levelArray[curSlideNum];
	        if ((skipTopicTitle) && (level == 2)) 
	        {
	        	sc.nextSlide(skipTopicTitle, skipGroupTitle);
	        	return;
	        }
	        else if ((skipGroupTitle) && (level == 11)) 
	        {
	        	sc.nextSlide(skipTopicTitle, skipGroupTitle);
	        	return;
	        }
	        sc.NewSlide(curSlideNum); 
	    }
	},
	
	getObject : function(index)
	{
		var obj=null;
		if ((index>=0) && (SlideController.getCurrentSlideNumber(index) < SlideController.getSlideCount()))
		{
			obj = idArray[index];
		}
		return obj;
	},
	
	prevSlide : function()
	{
		var sc = SlideController;
		if (curSlideNum > 0) 
		{
		    curSlideNum--;
		    var level = levelArray[curSlideNum];
		    if ((skipTopicTitle) && (level == 2)) 
		    {
		    	sc.prevSlide(skipTopicTitle, skipGroupTitle);
			    return;
		    }
		    else if ((skipGroupTitle) && (level == 11)) 
		    {
		    	sc.prevSlide(skipTopicTitle, skipGroupTitle);
			    return;
		    }
		    sc.NewSlide(curSlideNum); 
	    }
	},
	
	getSlideCount : function()
	{
		var count = 0;
		for (var i=0; i<levelArray.length; i++) 
		{
			if (levelArray[i] == 2) 
			{
				if (!skipTopicTitle) 
				{
					count++;
				}
			}
			else if (levelArray[i] == 11) 
			{
				if (!skipGroupTitle) 
				{
					count++;
				}
			}
			else {
				count++;
			}
		}
		return count;
	},
	getCurrentSlideNumber : function(slideNum)
	{
		if(slideNum==0) return 0;   var count = 0;
		for (var i=0; i<=slideNum; i++) 
		{
		   if (levelArray[i] == 2) 
		   {
			   if (!skipTopicTitle) 
			   {
				   count++;
			   }
		    }
		    else if (levelArray[i] == 11) 
		    {
		    	if (!skipGroupTitle) 
		    	{
		    		count++;
		    	}
		    }
		    else {
		      count++;
		    }
		  }
		  return count;
	},
	
	navigate : function(uniqueId, build)
	{
		var b = build || 0;
		var sc = SlideController;
		var slideNum = sc.findSlideNum(uniqueId);
		sc.NewSlide(slideNum+b);
	},
	
	NewSlide : function(slideNum)
	{
		var sc = SlideController;
		curSlideNum = slideNum;
		var level = levelArray[slideNum]; 
		var objID = idArray[slideNum]; 
		var groupID = '0'; 
		
		if ( level == 1 || level == 11) groupID = parentIDArray[objID]; 
		var baseviewer = window.frames["pres_body"].baseViewer;
		//if (baseviewer) launchLO(baseviewer);
		window.frames["pres_body"].location.href = urlMap[slideNum];
		sc.doTitle(slideNum);
	},
	
	getNavigatorInfo : function()
	{
		if (top.opener != null) 
		{
		    if (typeof(top.opener.NAVIGATOR) != "undefined") 
		    {
		       skipTopicTitle = top.opener.NAVIGATOR.skipTopicTitle;
		       skipGroupTitle = top.opener.NAVIGATOR.skipGroupTitle;
		    }
		}
	},
	
	launchLO : function(baseViewer)
	{
		if (typeof(top.opener.NAVIGATOR) != "undefined") 
		{
			top.opener.NAVIGATOR.LaunchLO();
		}
		else
		{
			var sc = SlideController;
			var topicID = "0";
			var groupID = "0";
			var loID = "0";
			var contentID = "0";
		
			var slideNum = curSlideNum;
			var levelNum = levelArray[slideNum];
			var objID = idArray[slideNum];
			if (loId) loID = loId;
			var tempLevel;
			var count = slideNum;
				while (count>=0) {
					tempLevel = levelArray[count];
					if (tempLevel == 11) { // Group Slide
						if (groupID=="0")
							groupID = idArray[count];
					}
					if (tempLevel == 2) { // Topic Slide
						if (topicID=="0")
							topicID = idArray[count];
					}
					count --;
				}
					
			if ((sc.currLoID != loID) || (sc.currTopicID != topicID) || (sc.currGroupID != groupID))
			{
				var servlet = "RloPage";
				if (loID == "0") servlet = "ContentViewer";
				var loURL = servlet + "?themeID="+baseViewer.themeID+"&studentID="+baseViewer.studentID;
				if (loID != "0")
					loURL += "&loID="+loID;
				if (topicID != "0")
					loURL += "&topicID=" + topicID;
				if (groupID != "0") {
					loURL += "&groupID="+groupID;
				}
				if ((baseViewer.LOWindow) && (!baseViewer.LOWindow.closed))
				{
					LOWindow = baseViewer.LOWindow;
				}
				if ((LOWindow) && (!LOWindow.closed)) 
				{
					window.open(loURL,"LearningObjectWindow",baseViewer.lowindowstyle+",width="+baseViewer.loWidth+",height="+baseViewer.loHeight);
				}
			}
			sc.currLoID = loID;
			sc.currTopicID = topicID;
			sc.currGroupID = groupID;
		}
	}
}

